libreorganize/apps/boxes/urls.py
from django.urls import path

from apps.boxes import views

app_name = "apps.boxes"

urlpatterns = [
    # Require VIEW permissions
    path("", views.ListView.as_view(), name="list"),
    path("files/", views.FileListView.as_view(), name="files_list"),
    # Require MANAGE permissions
    path("<int:pk>/edit/", views.EditView.as_view(), name="edit"),
    path("files/upload/", views.FileUploadView.as_view(), name="files_upload"),
    path("files/<int:pk>/delete/", views.FileDeleteView.as_view(), name="files_delete"),
]

libreorganize/apps/events/urls.py
from django.urls import path

from apps.events import utils, views

app_name = "apps.events"

urlpatterns = [
    # Require VIEW permissions
    path("", views.ListView.as_view(), name="list"),
    # Require MANAGE permissions
    path("create/", views.CreateView.as_view(), name="create"),
    path("<int:pk>/edit/", views.EditView.as_view(), name="edit"),
    path("<int:pk>/delete/", views.DeleteView.as_view(), name="delete"),
    path("<int:pk>/check/", views.CheckView.as_view(), name="check"),
    # Require NO permissions
    path("<int:pk>/", views.DetailView.as_view(), name="detail"),
    path("calendar/", views.CalendarView.as_view(), name="calendar"),
    path("subscribe/", utils.EventFeed(), name="subscribe"),
]

libreorganize/apps/news/urls.py
from django.urls import path

from apps.news import views

app_name = "apps.news"

urlpatterns = [
    # Require VIEW permissions
    path("newsletters/", views.NewsletterListView.as_view(), name="newsletters_list"),
    path("announcements/", views.AnnouncementListView.as_view(), name="announcements_list"),
    # Require MANAGE permissions
    path("newsletters/send/", views.NewsletterSendMailView.as_view(), name="newsletters_send"),
    path("newsletters/create/", views.NewsletterCreateView.as_view(), name="newsletters_create"),
    path("newsletters/<int:pk>/edit/", views.NewsletterEditView.as_view(), name="newsletters_edit"),
    path("newsletters/<int:pk>/delete/", views.NewsletterDeleteView.as_view(), name="newsletters_delete"),
    path("announcements/create/", views.AnnouncementCreateView.as_view(), name="announcements_create"),
    path("announcements/<slug:slug>/edit/", views.AnnouncementEditView.as_view(), name="announcements_edit"),
    path("announcements/<slug:slug>/delete/", views.AnnouncementDeleteView.as_view(), name="announcements_delete"),
    # Require NO permissions
    path("announcements/<slug:slug>/", views.AnnouncementDetailView.as_view(), name="announcements_detail"),
    path("newsletters/unsubscribe/<token>/", views.NewsletterUnsubscribeView.as_view(), name="newsletters_unsubscribe"),
]

libreorganize/apps/wikis/urls.py
from django.urls import path
from django.views.generic import RedirectView

from apps.wikis import views

app_name = "apps.wikis"

urlpatterns = [
    # Require MANAGE permissions
    path("create/", views.CreateView.as_view(), name="create"),
    path("<slug:slug>/edit/", views.EditView.as_view(), name="edit"),
    path("<slug:slug>/delete/", views.DeleteView.as_view(), name="delete"),
    # Require VIEW permissions
    path("", RedirectView.as_view(url="/wikis/home/"), name="home"),
    path("<slug:slug>/", views.DetailView.as_view(), name="view"),
]

libreorganize/core/urls.py
import os

from django.conf import settings
from django.conf.urls.static import static
from django.urls import include, path
from django.views.generic import TemplateView

urlpatterns = []

if os.path.exists(os.path.join(settings.BASE_DIR, "theme")):
    from theme.urls import *

urlpatterns += [
    path("", TemplateView.as_view(template_name="home.html"), name="home"),
    path("accounts/", include("apps.accounts.urls", namespace="accounts")),
    path("boxes/", include("apps.boxes.urls", namespace="boxes")),
    path("events/", include("apps.events.urls", namespace="events")),
    path("news/", include("apps.news.urls", namespace="news")),
    path("votations/", include("apps.votations.urls", namespace="votations")),
    path("wikis/", include("apps.wikis.urls", namespace="wikis")),
    path("i18n/", include("django.conf.urls.i18n")),
    path("ckeditor/", include("ckeditor_uploader.urls")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

libreorganize/core/views.py
from django.contrib import messages
from django.http import HttpResponseRedirect
from django.shortcuts import render, reverse
from django.utils.translation import gettext_lazy as _
from django.views import View

from core.mixins import ModelMixin, PermissionMixin, GroupPermissionMixin, RedirectMixin


class CoreListView(PermissionMixin, View):
    personal = None
    permission = None
    model = None
    template_name = None

    def get(self, request):
        return render(request=request, template_name=self.template_name, context=self.get_context())

    def get_context(self):
        if self.model.__name__.lower() != "account" and hasattr(self.model, "groups"):
            instances = self.model.objects.filter(groups=None)
            if self.request.user.is_superuser:
                instances = self.model.objects.all()
            else:
                for group in self.request.user.groups.all():
                    instances = instances | self.model.objects.filter(groups=group)
                instances = instances.distinct()
        else:
            instances = self.model.objects.all()
        return {f"{self.model.__name__.lower()}_list": instances}


class CoreDetailView(PermissionMixin, ModelMixin, GroupPermissionMixin, View):
    personal = None
    permission = None
    model = None
    template_name = None

    def get(self, request):
        return render(request=request, template_name=self.template_name, context=self.get_context())

    def get_context(self):
        return {self.model.__name__.lower(): getattr(self, self.model.__name__.lower())}


class CoreCreateView(PermissionMixin, RedirectMixin, View):
    personal = None
    permission = None
    model = None
    form_name = None
    template_name = None

    def get(self, request):
        return render(request=request, template_name=self.template_name, context=self.get_context())

    def post(self, request):
        context = self.get_context()
        if context["form"].is_valid():
            context["form"].save()
            messages.success(request, _(f"The {self.model.__name__.lower()} has been successfully created."))
            return HttpResponseRedirect(self.next)
        return render(request=request, template_name=self.template_name, context=context)

    def get_context(self):
        if self.request.method == "POST":
            form = self.form_name(data=self.request.POST, files=self.request.FILES)
        else:
            form = self.form_name()

        if form.fields.get("groups") and not self.request.user.is_superuser:
            form.fields.pop("groups")

        return {"form": form}


class CoreEditView(PermissionMixin, ModelMixin, GroupPermissionMixin, RedirectMixin, View):
    personal = None
    permission = None
    model = None
    form_name = None
    template_name = None

    def get(self, request):
        return render(request=request, template_name=self.template_name, context=self.get_context())

    def post(self, request):
        context = self.get_context()
        if context["form"].is_valid():
            context["form"].save()
            messages.success(request, _(f"The {self.model.__name__.lower()} has been successfully edited."))
            return HttpResponseRedirect(self.next)
        return render(request=request, template_name=self.template_name, context=context)

    def get_context(self):
        if self.request.method == "POST":
            form = self.form_name(
                data=self.request.POST, files=self.request.FILES, instance=getattr(self, self.model.__name__.lower())
            )
        else:
            form = self.form_name(instance=getattr(self, self.model.__name__.lower()))

        if form.fields.get("groups") and not self.request.user.is_superuser:
            form.fields.pop("groups")

        return {"form": form}


class CoreDeleteView(PermissionMixin, ModelMixin, GroupPermissionMixin, RedirectMixin, View):
    personal = None
    permission = None
    model = None
    template_name = None

    def get(self, request):
        return render(request=request, template_name=self.template_name, context=self.get_context())

    def post(self, request):
        getattr(self, self.model.__name__.lower()).delete()
        messages.success(request, _(f"The {self.model.__name__.lower()} has been successfully deleted."))
        return HttpResponseRedirect(self.next)

    def get_context(self):
        return {}

libreorganize/core/templates/includes/dashboard.html
{% load static %}
{% load i18n %}
<div id="dashboard">
    <div class="container">
        <div class="dashboard-header core-font">
            <h1>{% trans "Welcome to the Dashboard" %}, <span class="font-weight-bold text-dark">{{ user.first_name }}</span>!</h1>
            <a class="core-button" id="close-dashboard" href="javascript:void(0);">
                <img src="{% static 'img/icons/close.png' %}" alt="Close dashboard icon">
            </a>
        </div>
        <div class="dashboard-body core-font">
            <ul>
                <li>
                    <div>
                        <img src="{% static 'img/dashboard/accounts.svg' %}" alt="Accounts icon">
                    </div>
                    <a class="btn btn-dark" href="{% url 'accounts:list' %}" style="flex: 0; line-height: 1.5;">
                        {% trans "Accounts" %}
                    </a>
                    <a class="btn btn-dark" href="{% url 'accounts:groups_list' %}" style="flex: 0; line-height: 1.5;">
                        {% trans "Groups" %}
                    </a>
                </li>
                <li>
                    <div>
                        <img src="{% static 'img/dashboard/boxes.svg' %}" alt="Boxes icon">
                    </div>
                    <a class="btn btn-dark" href="{% url 'boxes:list' %}" style="flex: 0; line-height: 1.5;">
                        {% trans "Boxes" %}
                    </a>
                    <a class="btn btn-dark" href="{% url 'boxes:files_list' %}" style="flex: 0; line-height: 1.5;">
                        {% trans "Files" %}
                    </a>
                </li>
                <li>
                    <div>
                        <img src="{% static 'img/dashboard/events.svg' %}" alt="Events icon">
                    </div>
                    <a class="btn btn-dark" href="{% url 'events:list' %}">
                        {% trans "Events" %}
                    </a>
                </li>
                <li>
                    <div>
                        <img src="{% static 'img/dashboard/news.svg' %}" alt="News icon">
                    </div>
                    <a class="btn btn-dark" href="{% url 'news:newsletters_list' %}" style="flex: 0; line-height: 1.5;">
                        {% trans "Newsletters" %}
                    </a>
                    <a class="btn btn-dark" href="{% url 'news:announcements_list' %}" style="flex: 0; line-height: 1.5;">
                        {% trans "Announcements" %}
                    </a>
                </li>
                <li>
                    <div>
                        <img src="{% static 'img/dashboard/votations.svg' %}" alt="Votation icon">
                    </div>
                    <a class="btn btn-dark" href="{% url 'votations:list' %}">
                        {% trans "Votations" %}
                    </a>
                </li>
                <li>
                    <div>
                        <img src="{% static 'img/dashboard/wikis.svg' %}">
                    </div>
                    <a class="btn btn-dark" href="{% url 'wikis:view' slug='home' %}" alt="Wikis icon">
                        {% trans "Wikis" %}
                    </a>
                </li>
                <li>
                    <div>
                        <img src="{% static 'img/dashboard/report_issue.svg' %}" alt="Report Issue icon">
                    </div>
                    <a class="btn btn-warning" href="https://gitlab.com/libreorganize/libreorganize/-/issues/new">
                        {% trans "Report Issue" %}
                    </a>
                </li>
            </ul>
        </div>
    </div>
</div>

libreorganize/core/templates/includes/footer.html
{% load static %}
<div class="text-center core-font">
    <p>Developed and Powered by</p>
    <div>
        <a href="https://novawebdevelopment.org/"><img src="{% static 'img/logos/novawebdevelopment.png' %}" alt="NOVA Web Development logo"></a>
        <a href="https://libreorganize.org/"><img src="{% static 'img/logos/libreorganize.png' %}" alt="LibreOrganize logo"></a>
    </div>
    <p>Copyright &copy; 2020 - Licensed under Creative Commons Attribution - No Derivative Works 3.0 (or later version)</p>
</div>

libreorganize/core/templates/includes/messages.html
{% if messages %}
<div class="fixed-top message-wrapper core-font">
    {% for message in messages %}
    <div class="alert alert-{{ message.tags }} alert-message alert-dismissible fade show" role="alert">
        {{ message }}
        <button type="button" class="close" data-dismiss="alert">
            <span aria-hidden="true"><i class="fas fa-times fa-fw"></i></span>
        </button>
    </div>
    {% endfor %}
</div>
{% endif %}

libreorganize/core/templates/includes/navbar.html
{% load static %}
{% load i18n %}

<nav class="navbar navbar-expand-md core-font">
    <a class="navbar-brand" href="{% url 'home' %}"><img src="{% static 'img/logos/website.png' %}"></a>
    <div class="core-div">
        <form action="{% url 'set_language' %}" method="post" id="languageForm" style="display: inline-block;">
            {% csrf_token %}
            {% get_current_language as LANGUAGE_CODE %}
            {% if LANGUAGE_CODE == 'en' %}
            <input name="language" type="hidden" value="es">
            {% else %}
            <input name="language" type="hidden" value="en">
            {% endif %}
            <a onclick="document.getElementById('languageForm').submit()" class="core-button" href="javascript:void(0);">
                <img src="{% static 'img/icons/translate.png' %}">
            </a>
        </form>
        {% if user.is_authenticated %}
        {% if perms %}
        <a class="core-button" id="open-dashboard" href="javascript:void(0);"><img src="{% static 'img/icons/dashboard.png' %}"></a>
        {% endif %}
        <a class="core-button" href="{% url 'accounts:detail' pk=user.pk %}?personal=true"><img
                src="{% static 'img/icons/profile.png' %}"></a>
        <a class="core-button" href="{% url 'accounts:logout' %}"><img src="{% static 'img/icons/logout.png' %}"></a>
        {% else %}
        <a class="core-button" href="{% url 'accounts:login' %}">
            <img src="{% static 'img/icons/login.png' %}"></a>
        {% endif %}
        <a class="core-button d-md-none" href="javascript:void(0);" data-toggle="collapse" data-target="#mobileNavbar"
            aria-controls="mobileNavbar">
            <img src="{% static 'img/icons/menu.png' %}"></a>
    </div>
    <div class="collapse navbar-collapse" id="mobileNavbar">
        <div class="navbar-nav ml-auto">
            <a class="nav-item nav-link" href="{% url 'home' %}">{% trans "Home" %}</a>
            <a class="nav-item nav-link" href="{% url 'events:calendar' %}">{% trans "Calendar" %}</a>
            <a class="nav-item nav-link" href="{% url 'wikis:view' slug='home' %}">{% trans "Wiki" %}</a>
            <a class="nav-item nav-link" href="{% url 'votations:public_list' %}">{% trans "Votation" %}</a>
        </div>
    </div>
</nav>